#!/bin/sh


FALSE=1
TRUE=0

YES=0
NO=1
QUIT=2
INVALID=99
userDebug=0
if test $userDebug -eq 1
then
echo "enter debug model"
#set -x
#configfile="./cfg"
#upsconfig="./upsconfig"
configfile="/usr/lib/powerassistant/config"
upsconfig="/usr/lib/powerassistant/upsconfig"
gettext="/usr/lib/powerassistant/gettext"
else
configfile="/usr/lib/powerassistant/config"
upsconfig="/usr/lib/powerassistant/upsconfig"
gettext="/usr/lib/powerassistant/gettext"
fi
pa="poweragent"
agentmanage="/usr/lib/powerassistant/agentmanage"

###########################################
# echo when debug
###########################################
decho() {
        
if test $userDebug -eq 1
then
	tmp_name=`uname -s`
	string="$1"

	if [ "$tmp_name" = "Linux" ]
	then
		echo -e `$gettext "$string"`
	elif [ -r /usr/5bin/echo ]
        then
		/usr/5bin/echo "$string"
	else
		echo "$string"
	fi
fi
}





##################################################
# set the default parameters
########################################
set_parameters() {		
	if test -e $configfile;then
		decho "enter config:$configfile"
		tmp=`cat $configfile|grep EXPECTBLIFE|awk '{print $3}'`
		if test $? -eq 0
		then
			delay=$tmp
		fi
		tmp=`cat $configfile|grep FIRSTWARN|awk '{print $3}'`
		if test $? -eq 0
		then
			first_time=$tmp
		fi
		tmp=`cat $configfile|grep INTERVAL|awk '{print $3}'`
		if test $? -eq 0
		then
			interval=$tmp
		fi
		cat $configfile|grep TurnOffDelay > /dev/null 2>&1
		if test $? -eq 0
		then
		tmp=`cat $configfile|grep TurnOffDelay|awk '{print $3}'`
		if test $? -eq 0
		then
			shutdown_time=$tmp
			closeapp_time=$tmp
		fi
		fi
		cat $configfile|grep ComSet > /dev/null 2>&1
		if test $? -eq 0
		then
		tmp=`cat $configfile|grep ComSet|awk '{print $3}'`
		if test $? -eq 0
		then
			ComSet=$tmp
			let ComSet=$ComSet+1
			decho "ComSet=$ComSet"
		fi
		fi
	fi
			decho "ComSet in first:$ComSet"
	        case "$ComSet" in
            -1)
				ComPortName=COM-NONE
                ;;
            1)
				ComPortName=AutoTest
                ;;
            2)
				ComPortName=COM1
                             ;;
            3)
				ComPortName=COM2
                ;;
            4)
				ComPortName=COM3
                ;;
            5)      
				ComPortName=COM4
                                 ;;
            *)
			 	ComPortName=AutoTest
                ;;
        esac
		
		ComPortName=${ComPortName:=AutoTest}
		ComSet=${ComSet:=1}
		delay=${delay:=60}
		first_time=${first_time:=30}
		shutdown_time=${shutdown_time:=600}
		interval=${interval:=30}
		decho "Parameters get :"
		decho "comset=$ComSet; ComPortName=$ComPortName; delay=$delay; first_time=$first_time; shutdown_time=$shutdown_time; interval=$interval"
		delay_max=36000
		delay_min=0
		shutdown_time_max=600
		shutdown_time_min=0
		first_time_max=30000
		first_time_min=1
		interval_max=30000
		interval_min=5
}
		
###############################


IsYN(){
    VALID_YN=$FALSE
    YN=
    rval=
    Echo "[y/n] "
  #  Echo "[y/n] \\c"
    read YN
    if [ -z "$YN" ]
    then
        VALID_YN=$FALSE
        rval=$INVALID
    else
        case "$YN" in
        [Yy]*)
            VALID_YN=$TRUE
            rval=$YES
            ;;
        [Nn]*)
            VALID_YN=$TRUE
            rval=$NO
            ;;
        *)
            VALID_YN=$FALSE
            rval=$INVALID
            ;;
        esac
    fi
    if [ $rval -eq $INVALID ]
    then
        beep
        #Echo "Invalid Response..."
	Echo "Invalid input"
	Echo "Input again please"
    fi
    return $rval
}


is_yn(){
    VALID_YN=$FALSE
    YN=
    rval=
    read YN
    if [ -z "$YN" ]
    then
        VALID_YN=$FALSE
        rval=$INVALID
    else
        case "$YN" in
        [Yy]*)
            VALID_YN=$TRUE
            rval=$YES
            ;;
        [Nn]*)
            VALID_YN=$TRUE
            rval=$NO
            ;;
        *)
            VALID_YN=$FALSE
            rval=$INVALID
            ;;
        esac
    fi
    if [ $rval -eq $INVALID ]
    then
        beep
        #Echo "Invalid Response..."
    Echo_wrong
	fi
    return $rval
}
Echo_wrong(){
	Echo "Invalid input."
	Echo "Input again, please."
}

Echo_wrong_date(){
	Echo "Invalid  date input."
	Echo "Input date again, please."
}

IsYNLoop_org() {
    rval=$INVALID
    query_string="$1"
    valid_response=$FALSE
    while [ $valid_response -eq $FALSE ]
    do
        Echo "$query_string"
        IsYN
        rval=$?
        case "$rval" in
            $YES|$NO)
                valid_response=$TRUE
                ;;
        esac
    done
    return $rval
}


IsYNLoop() {
    rval=$INVALID
    query_string="$1"
    valid_response=$FALSE
    while [ $valid_response -eq $FALSE ]
    do
        Echo "$query_string"
        #IsYN
		is_yn
        rval=$?
        case "$rval" in
            $YES|$NO)
                valid_response=$TRUE
                ;;
        esac
    done
    return $rval
}

yn_loop() {
    rval=$INVALID
    query_string="$1"
    valid_response=$FALSE
    while [ $valid_response -eq $FALSE ]
    do
        Echo "$query_string"
        is_yn
        rval=$?
        case "$rval" in
            $YES|$NO)
                valid_response=$TRUE
                ;;
        esac
    done
    return $rval
}

head_zero_clear(){
	return `echo "$1"|sed 's/^[0][0]*//g'`
}


month_day(){
awk '
BEGIN{
	y = '$1'
	m='$2'
	if( (y%4==0) && (((y%100)) || !(y%400)) )
		add = 1
	else
		add = 0
	x = "1 31 2 28 3 31 4 30 5 31 6 30 "\
		"7 31 8 31 9 30 10 31 11 30 12 31 1 31"
	split(x, data, " ")
	for(i=1; i<24; i+=2){
		days[data[i]] = data[i+1]
		if(data[i] == 2)
			days[data[i]] += add
		if(data[i] == m)
			printf("%s\n", days[m]);
	}
	} '
}


IsDigital(){
    query_string_tmp="$1"
 
	echo $query_string_tmp|grep '^[0-9][0-9]*$'>/dev/hull
	rval=$?
    return $rval

}

ConvertDate() {

#    query_string="$1"
    query_string=$change_date
#	decho "before:$query_string"
	decho
	decho "before: $change_date"
	change_date=`echo $query_string|awk -F/ '{printf "%d,%d,%d,00,00,00",$1-1900, $2, $3}'`
#	change_date=`echo $query_string|awk -F/ '{printf "%d,%d,%d,00,00,00",$1, $2, $3}'`
	let rval=$?
	decho "Convert:$change_date"
	if test $rval -eq 0
	then 
		return $TRUE
	else
		return $FALSE
	fi
	change_date=`echo $change_date|sed 's/\//,/g'`
	change_date=`echo $change_date|sed 's/$/,00,00,00/g'`

}

ReConvertDate() {

    query_string="$1"
   # query_string=$change_date
	decho "before:$query_string"
	decho
	#decho "before: $change_date"
	change_date_r=`echo $query_string|awk -F, '{printf "%d/%02d/%02d",$1+1900, $2, $3}'`
#	change_date=`echo $query_string|awk -F/ '{printf "%d,%d,%d,00,00,00",$1, $2, $3}'`
	let rval=$?
	decho "Convert:$change_date_r"
	if test $rval -eq 0
	then 
		return $TRUE
	else
		return $FALSE
	fi
}


IsValidDate(){
	query_string="$1"
	if test -z $query_string
	then
		decho "Null string"
		return 1
	fi
	result1=`echo $query_string|cut -d"/" --fields 1`
	decho "year:$result1"
	IsDigital $result1
		case "$?" in
		$FALSE)
			return $FALSE
			;;
		
		$TRUE)
#			return $TRUE
			;;
		esac
		
	if test $result1 -lt 1900
	then
		decho "too early or error"
		return 1
	fi
	if test $result1 -gt 2154
	then 
		decho "time beyond the scope"
		return 1
	fi
	year_st=$result1

	result1=`echo $query_string|cut -d"/" --fields 2`
#	result=`echo $query_string|awk -F/ '{print $2}'`
	decho "month:$result1"
	IsDigital $result1
		case "$?" in
		$FALSE)
			return $FALSE
			;;
		
		$TRUE)
#			return $TRUE
			;;
		esac

	if test $result1 -eq 0
	then
		Echo "month is error" 
		return 1
	fi
	if test $result1 -gt 12
	then 
		Echo "month is error" 
		return 1
	fi

	#let month_st=$result1
	decho "contain 0:$result1"
	head_zero_clear $result1
	#month_st=$result1
	let month_st=$?
	decho "clear 0:$month_st"

	result1=`echo $query_string|cut -d"/" --fields 3`
	decho "day:$result1"
	IsDigital $result1
		case "$?" in
		$FALSE)
			return $FALSE
			;;
		
		$TRUE)
#			return $TRUE
			;;
		esac

	day_number=`month_day $year_st $month_st`
	if test $result1 -eq 0
	then
		decho "Day is error"
		return 1
	fi
	#if test $result1 -gt  31
	if test $result1 -gt $day_number
	then 
		decho "Day is error"
		return 1
	fi


}

Echo() {
        
	tmp_name=`uname -s`
	string="$1"

	if [ "$tmp_name" = "Linux" ]
	then
		echo -e `$gettext "$string"`
	elif [ -r /usr/5bin/echo ]
        then
		/usr/5bin/echo "$string"
	else
		echo "$string"
	fi
}


echo_line() {
	Echo "--------------------------------------------------------------------"
}


beep() {
	Echo "\\c"
}

prompt_index(){		
		Echo "Select index:\\c" 
}

prompt_modify_yn(){
	yn_loop "Are the modified parameters correct? press [Y] to accept them, press [N] to modify them."
}

prompt_runagent_yn(){
	yn_loop "Do you want to run agent? press [Y] to run agent, press [N] not to run it."
}

prompt_para_yn(){
#IsYNLoop "Are the above selections correct? press [Y] to accept them, press [N] to modify them. input\\c"
	yn_loop "Are the above selections correct? press [Y] to accept them, press [N] to modify them."
}	

prompt_cc_msg(){
	echo
	Echo "upsconfig stopped, ups config parameters can be set later."
	Echo " usage: /usr/lib/powerassistant/upsconfig.sh"
}	

#####################################################
# About battery 
#####################################################a
input_verify_batterydate() {

		#ask for battery change time
	
#		Echo "Your UPS is a maintainable UPS. Please input Change Battery Date: yyyy/mm/dd"
#		Echo "Please input Change Battery Date: yyyy/mm/dd"
#		echo
		echo_line
		Echo "Battery Change Time Input Menu"
		echo_line
		Echo "input battery time, forecast the next battery change time"
		Echo "accroding to battery change time, input the date"
		Echo "Such as:2000/01/31"

	Select_OK=$FALSE
	while [ $Select_OK -eq $FALSE ]
	do
    	  VALID_SELECTED=$FALSE 
	   while [ $VALID_SELECTED -eq $FALSE ]
	    do

#		Echo "Date[2000/01/31]:\\c"
		Echo "Please input Battery change date."
		Echo "Change Battery Date:\\c"
		read change_date
#		change_date=${change_date:="2000/01/31"}
 		IsValidDate $change_date
		case "$?" in
		$FALSE)
			VALID_SELECTED=$FALSE
			beep
			#Echo "Invalid input, Input again"
			#Echo_wrong
			Echo_wrong_date
			;;
		
		$TRUE)
			VALID_SELECTED=$TRUE
			;;
		esac
	done

	#IsYNLoop "The Battery Change Time just input is:$change_date.  Is it right? press [Y] to accept it,press [N] to modify it. input\\c"
	#Echo "The Battery Change Time just input is:\\c"
	Echo "Battery Change Time[\\c"
	echo  -e "$change_date\c"
	Echo "]is just input."
  	Echo "Is it right?" 
	##############???????????\\c
	Echo "press [Y] to accept it, press [N] to modify it.\\c"
	#IsYNLoop  "input\\c"
	yn_loop "\\c"
	case "$?" in
		$NO)
#			Echo 
#			Echo "Please re-input the parameters again "
#			Echo 
			Select_OK=$FALSE
			;;
		$YES)
			Select_OK=$TRUE
			;;
	esac
done

}

get_set_battery() {
	
	if test $ComSet -eq 6;then
		return 0
	fi
	if test $ComSet -eq -1;then
		return 0
	fi
	
#	Echo "Please waiting..."
#	Echo "Testing UPS Battery Change Time. Please wait..."
	Echo "Testing UPS Battery Change Time."
	Echo "Please wait...."
	Echo "if necessary, input battery change time imediately"
	Echo "else, do not input battery change time"
	Echo "you can do this according the following step"
#	echo
#	comid is the number of com port: 0-AutoTest, 1-COM1, 2-COM2, 3-COM3, 4-COM4

	let comid=$ComSet-1
	$upsconfig -g "batt" $comid >/dev/null 2>&1
	let batt_result=$?
#	let batt_result=1
	decho "battery: $?  $batt_result"
	if test $batt_result -eq 255;then
		$upsconfig -g "batt" $comid >/dev/null 2>&1
		let batt_result=$?
		decho "battery: $?  $batt_result"
	fi

	while test $batt_result -eq 255 
	do
		echo_line
#			Echo "WARNING: Could not communicate with device on the port you selected."
			Echo "WARNING:"
			echo_line
			Echo "Could not communicate with device on the port you selected."
			Echo "Check that the communications cable is attached properly to both the device"
			Echo "and the serial port. Sometimes, it is because the data response not correctly,"
			Echo "so try several times is recommanded."
			beep
			echo_line
			Echo "ASKING:"
			echo_line
			Echo "exit_?"
			Echo "retry_?"
			
			let VALID_RE=$FALSE
			while test $VALID_RE -eq $FALSE 
			do
				Echo "Do you wish to Exit or Retry communications? [R/E] \\c"
				read RE
				case "$RE" in
				[Rr]*)
					RETRY=$TRUE
					VALID_RE=$TRUE
					$upsconfig -g "batt" "$comid" > /dev/null 2>&1
					let batt_result=$?
					decho "battery: $?  $batt_result"
					if test $batt_result -eq 255;then
						$upsconfig -g "batt" $comid >/dev/null 2>&1
						let batt_result=$?
						decho "battery: $?  $batt_result"
					fi
					;;
				[Ee]*)
					COMM_VERIFIED=$FALSE
					RETRY=$FALSE
					VALID_RE=$TRUE
					#IsYNLoop "Do you want to run agent?  \\c"
					prompt_runagent_yn
					case "$?" in
					$NO)
						Echo 
						Echo 
						exit
						;;
					$YES)
						run_agent
						exit
						;;
					esac

					;;
				esac
			done
	done

	#if batt_result=2, it is a maintainable UPS, such as BNxxx
	if test $batt_result -eq 2  
	then 
		input_verify_batterydate
		echo_line
		$upsconfig -s batt "$change_date" $comid > /dev/null 2>&1
		let batt_result=$? 

		while test $batt_result -eq 255 
		do
			echo_line
			Echo "WARNING: write date to UPS failed this time, can try several times"
			beep
			echo_line
			
			let VALID_RE=$FALSE
			while test $VALID_RE -eq $FALSE 
			do
				Echo "Do you wish to Exit or Retry  [R/E] \\c"
				read RE
				case "$RE" in
				[Rr]*)
					RETRY=$TRUE
					VALID_RE=$TRUE
					$upsconfig -s batt "$change_date" $comid > /dev/null 2>&1
					let batt_result=$?
					;;
				[Ee]*)
					COMM_VERIFIED=$FALSE
					RETRY=$FALSE
					VALID_RE=$TRUE
					#exit
					;;
				esac
			done
		done
	#if =1, it's UPS such as BXxxx, which can be get from config file , not from ups		
	elif test $batt_result -eq 1
	then
		time_exist=`grep ChangeBattTime $configfile`
		time_exist=`echo $time_exist|awk '{print $3}'`
		decho "battery time is config file is:$time_exist"
		ReConvertDate $time_exist
		input_verify_batterydate
		##############

#######################################3		
		echo
		ConvertDate
		$upsconfig -s '[ UPS ]' ' ChangeBattTime' "$change_date" > /dev/null 2>&1
		let batt_result=$?
		decho "battery: $?  $batt_result"
		if test $batt_result -eq 255;then
			$upsconfig -g "batt" $comid >/dev/null 2>&1
			let batt_result=$?
			decho "battery: $?  $batt_result"
		fi
		if test $batt_result -eq 255;then
			$upsconfig -g "batt" $comid >/dev/null 2>&1
			let batt_result=$?
			decho "battery: $?  $batt_result"
		fi
	fi


#	if test $? -eq 0
#	then
	#	Echo "UPS config file build completed. "
	#	echo
#	else
#		Echo "UPS config file build  failed. "
##	fi
	if test $batt_result -eq 255; then
		decho "Battery Change Time setup failed."
	else
		echo
	fi
	Echo "Battery Change Time setup complete."
}

GetCurrentDate() {
	#get current date in format: yyyy/mm/dd/hh/mm/ss
	current_date=`date '+%Y/%m/%d/%H/%M/%S'`
	current_date_short=`date '+%Y/%m/%d'`
#	echo "date:$current_date"
#	echo "date:$current_date_short"

}

run_agent() {
#	return 0
	if [ -x /usr/lib/powerassistant/poweragent -a -x /usr/lib/powerassistant/agentmanage ]
	then
		#Echo "Begin to start poweragent... "
		echo
		Echo "Begin to start poweragent."
		Echo "Please wait..."
		echo
		/usr/lib/powerassistant/agentmanage -r>/dev/null 2>&1
		if [ $? = 0 ]; then
#			/usr/lib/powerassistant/agentmanage -r >/dev/null 2>&1
			/usr/lib/powerassistant/poweragent>/dev/null 2>&1
		fi

		let n_pr=`ps fx|grep "$pa"|awk 'END {print NR}'`
		decho "ps=$n_ps; pr=$n_pr"
		if [  $n_pr -gt 1 ]; then
	            Echo "PA has been started for you. "
        else
			sleep 2
	        /usr/lib/powerassistant/agentmanage -r>/dev/null 2>&1
	        if [ $? = 0 ]; then
        	    /usr/lib/powerassistant/poweragent>/dev/null 2>&1
	        fi

    	    let n_pr=`ps fx|grep "$pa"|awk 'END {print NR}'`
        	decho "ps=$n_ps; pr=$n_pr"
	        if [  $n_pr -gt 1 ]; then
                Echo "PA has been started for you. "
    	    else
                Echo "PA start failed. "
        	fi
        fi 
												
		#if [ $? = 0 ]; then
		#	decho "PA has been started for you. "
		#else
		#	decho "PA start failed. "
		#fi
	fi   
#	Echo " "
#	Echo "Now, you can run /usr/lib/powerassistant/agentmanage to manage the UPS."
	Echo "Now, you can use agentmanage to manage UPS"
	Echo "Usage: /usr/lib/powerassistant/agentmanage"
	echo_line

}


########################################################################
# Pre ups config
#########################################################################
preprocess() {

	#trap 'echo "receive signal ^c";prompt_cc_msg;exit' 2 
	trap 'prompt_cc_msg;exit' 2 
	gettext=/usr/lib/powerassistant/gettext
	if [ "AutoTest" = `$gettext "AutoTest"` ];then
       let ja=0 
	else
       let ja=1 
	fi
	if [ ! -f $upsconfig ]
	then
		Echo "Config file:\\c"
		echo -e " $upsconfig \\c"
		Echo "not exist!"
		exit 
	fi
	$upsconfig -g pr $pa > /dev/null 2>&1
	let n_ps=$?
	let n_pr=`ps fx|grep "$pa"|awk 'END {print NR}'`
	decho "ps=$n_ps; pr=$n_pr"
	if [ $n_ps -gt 1  -o  $n_pr -gt 1 ]
	then
		echo
		Echo  "The PA is Running"
#		Echo "You must stop it before config"
#		Echo "usage: \\c"
#		echo -e "$agentmanage\\c"
#		echo "  -s"
#		echo
		Echo "setup the configuration first ,then run PA"
		Echo "so, you must stop the PA now"
		echo
		Echo "Usage of stop agent: "
		echo  "$agentmanage -s"
		echo
		Echo "After you stopped the PA, you can setup the config parameters"
		echo
		Echo "Usage of setup config: "
		echo "$upsconfig.sh"
		echo_line
		exit
	fi
}


#######################################################################
# Verify root authority 
#######################################################################
verify_root() {
    root_string=`id | grep root`

    if [ -z "$root_string" ]
    then
        ROOT_USER=$FALSE
        echo_line
        beep
	echo -e "$0 \\c"
        Echo " must be run with root privileges!"
        echo_line
        echo_line
        IsYNLoop "Do you wish to continue anyway?"
        case "$?" in
            $NO)
                exit
                ;;
        esac
    else
        ROOT_USER=$TRUE
    fi

}


#######################################################################
#************* Print Banner  *******************
#######################################################################
Echo "-----------------------------------------------------------"
Echo "     PA for Linux  Configuration   "
#Echo "             Copyright  1999"
Echo "-----------------------------------------------------------"
Echo
	preprocess
#	verify_root
	set_parameters

##############################################################
# Display the default parameters 
###############################################################
	Echo
	Echo "The following is the default parameters. "
	Echo 

	
	echo_line
	
    Echo "COM PORT\\c"
	if [ $ja -eq 0 ];then
	echo -e "\t\t\t\t\t:\\c"
	else
	echo -e "\t\t\t:\\c"
	fi
	decho "|$ComPortName|"
	Echo  "$ComPortName"

	Echo " AC Fail Delay(seconds) \\c"
	if [ $ja -eq 0 ];then
	echo -e "\t\t\t\t: ${delay}"
	else
	echo -e "\t\t: ${delay}"
	fi
    
    Echo " First Warning Time After AC Fail(seconds) \\c"
	if [ $ja -eq 0 ];then
	echo -e "\t: ${first_time}"
	else
	echo -e "\t\t\t\t: ${first_time}"
	fi
    
	  Echo " System Shutdown Needed Time(seconds) \\c"
	if [ $ja -eq 0 ];then
	echo -e "\t\t: $shutdown_time"
	else
	echo -e "\t: $shutdown_time"
	fi
    
     Echo " Warning Interval(seconds)  \\c"
	if [ $ja -eq 0 ];then
	echo -e "\t\t\t: $interval"
	else
	echo -e "\t\t\t\t: $interval"
	fi
    
   
	echo_line
    Echo

#######################################################
#Default parameters
#else write them to config file
###################################################
#IsYNLoop "Are the above parameters correct?    \\c"
#IsYNLoop "Are the above selections correct? If you want to accept them, please press [Y],if you want to modify them, please press [N]. Please input\\c"
#IsYNLoop "Are the above selections correct? press [Y] to accept them, press [N] to modify them. input\\c"
prompt_para_yn
case "$?" in
		$YES)
		Echo 
# !		Echo "The default config parameters are correct "
#		Echo 
#		exit ##########!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

#		Echo 
		Echo "now, build config file according to the selection "
		Echo 
		echo_line
	
		decho "##comset=$ComSet"	
		case "$ComSet" in
	        1) $upsconfig -s "[ UPS ]" " ComSet" 0
			;;
        	2) $upsconfig  -s "[ UPS ]" " ComSet" 1
	        ;;
    	    3) $upsconfig  -s "[ UPS ]" " ComSet" 2
        	;;
		    4) $upsconfig  -s "[ UPS ]" " ComSet" 3
		    ;;
        	5) $upsconfig  -s "[ UPS ]" " ComSet" 4
	        ;;
        	-1) $upsconfig  -s "[ UPS ]" " ComSet" "-2"
	        ;;
    	esac

		$upsconfig -s "[ ShutDown ]" " EXPECTBLIFE" $delay
		$upsconfig -s "[ ShutDown ]" " FIRSTWARN" $first_time
		$upsconfig -s "[ ShutDown ]" " INTERVAL" $interval
		$upsconfig -s "[ ShutDown ]" " TurnOffDelay" $shutdown_time
		closeapp_time=`expr  $shutdown_time \/ 2`
		$upsconfig -s "[ ShutDown ]" " CloseAppTime" $closeapp_time
		get_set_battery
		run_agent	
		exit

		;;
		$NO)

		;;
esac


##############A BIG CIRCLE ################

	Echo "If you press <Enter> ,the default value will be selected"
	Echo

Select_OK=$FALSE
echo_line
Echo "Please input the new parameters according the following prompt"
echo
while [ $Select_OK -eq $FALSE ]
do
#######################################################################
# Select com port
#######################################################################
	Echo "1. Serial No. Selection"
	Echo "Select the serial No which the UPS is attached to.(default=[1]:AutoTest)"
#        Echo " 1) Autotest COM port"
		Echo " 1) AutoTest"
		Echo " 2) COM1"
        Echo " 3) COM2"
        Echo " 4) COM3"
        Echo " 5) COM4"
        Echo " 6) COM-NONE"
        Echo " "
    VALID_HARDWARE_SELECTED=$FALSE 
    INST_HARDWARE=
    while [ $VALID_HARDWARE_SELECTED -eq $FALSE ]
    do
    #    Echo "Which COM port will be running with  \\c"
    #    Echo "Please select the index(1~5) \\c"
		#Echo "Select index:\\c" 
		prompt_index
#		echo  -e " [$ComSet] \\c"
		ComSet_tmp=$ComSet
		read ComSet
##		ComSet=${ComSet:=$ComSet_tmp}
        ComSet=${ComSet:=1}
        case "$ComSet" in

            1)
				VALID_HARDWARE_SELECTED=$TRUE
				ComPortName=AutoTest
                ;;
            2)
                VALID_HARDWARE_SELECTED=$TRUE
				ComPortName=COM1
                             ;;
            3)
                VALID_HARDWARE_SELECTED=$TRUE
				ComPortName=COM2
                ;;
            4)
                VALID_HARDWARE_SELECTED=$TRUE
				ComPortName=COM3
 
                ;;
            5)      
                VALID_HARDWARE_SELECTED=$TRUE
				ComPortName=COM4
                                 ;;
            6)      
                VALID_HARDWARE_SELECTED=$TRUE
				ComPortName=COM-NONE
                                 ;;
            *)
                VALID_HARDWARE_SELECTED=$FALSE                
                beep
               # Echo "Invalid Selection...."
		Echo_wrong
        esac
    done
	echo_line




#######################################################################
# input :
#		AC Fail Delay 
#		First Warning Time After AC Fail
#		System Shutdown Needed Time
#		Warning Interval
#######################################################################
#	echo
#	Echo "Now, input the following parameters:"
#	echo
#	echo_line
	Echo "2. AC Fail Delay"
	Echo "AC Fail Delay is the time when system begin shutdown after AC fail occurs.Its value can be from 0s to 36000s(default=60s)"
    VALID_SELECTED=$FALSE 
   while [ $VALID_SELECTED -eq $FALSE ]
    do
	Echo "Input AC Fail Delay(seconds) \\c"
	#	echo -e " [$delay]:\\c" 
        delay_tmp=$delay
		read delay
##		delay=${delay:=$delay_tmp}
        delay=${delay:=60}
		IsDigital $delay
		case "$?" in
		$FALSE)
			VALID_SELECTED=$FALSE
			beep
			Echo "Invalid input, Input again"
			;;
		
		$TRUE)
			if test $delay -gt $delay_max
			then
				VALID_SELECTED=$FALSE
				beep
#				Echo "Invalid input, Input again"
				Echo_wrong
			elif test $delay -lt $delay_min
			then
				VALID_SELECTED=$FALSE
				beep
#				Echo "Invalid input, Input again"
				Echo_wrong
			else
				VALID_SELECTED=$TRUE
			fi
			;;
	esac
	echo_line
    done

	Echo "3. System Shutdown Needed Time" 
	Echo "System Shutdown Needed Time is the time span between system begin shutdown and system shutdown finished(default=[15]:600s)"
      VALID_SELECTED=$FALSE 
	case $shutdown_time in
		30)
			let shut_time_select=1
			;;
		36)
			let shut_time_select=2
			;;
		42)
			let shut_time_select=3
			;;
		48)
			let shut_time_select=4
			;;
		54)
			let shut_time_select=5
			;;
		60)
			let shut_time_select=6
			;;
		120)
			let shut_time_select=7
			;;
		180)
			let shut_time_select=8
			;;
		240)
			let shut_time_select=9
			;;
		300)
			let shut_time_select=10
			;;
		360)
			let shut_time_select=11
			;;
		420)
			let shut_time_select=12
			;;
		480)
			let shut_time_select=13
			;;
		540)
			let shut_time_select=14
			;;
		600)
			let shut_time_select=15
			;;
		*)
			let shut_time_select=15
			;;
	esac
		

	  #Echo " System shutdown Needed Time should be select from the following list:"
	  echo " 1)  30		2)  36		3)  42		4)  48		5)  54"
	  echo " 6)  60		7)  120		8)  180		9)  240		10) 300"
	  echo " 11) 360	12) 420		13) 480		14) 540		15) 600"
   while [ $VALID_SELECTED -eq $FALSE ]
    do
	  prompt_index
	  #Echo " System Shutdown Needed Time(select from No.1~15) \\c"
	  #echo -e "[$shut_time_select]: \\c"
		shut_time_select_tmp=$shut_time_select
		read shut_time_select
##		shut_time_select=${shut_time_select:=$shut_time_select_tmp}
		shut_time_select=${shut_time_select:=15}
		case $shut_time_select in
			1)
			  VALID_SELECTED=$TRUE
			  shutdown_time=30
			  ;;
			2)
			  VALID_SELECTED=$TRUE
			  shutdown_time=36
			  ;;
			3)
			  VALID_SELECTED=$TRUE
			  shutdown_time=42
			  ;;
			4)
			  VALID_SELECTED=$TRUE
			  shutdown_time=48
			  ;;
			5)
			  VALID_SELECTED=$TRUE
			  shutdown_time=54
			  ;;
			6)
			  VALID_SELECTED=$TRUE
			  shutdown_time=60
			  ;;
			7)
			  VALID_SELECTED=$TRUE
			  shutdown_time=120
			  ;;
			8)
			  VALID_SELECTED=$TRUE
			  shutdown_time=180
			  ;;
			9)
			  VALID_SELECTED=$TRUE
			  shutdown_time=240
			  ;;
			10)
			  VALID_SELECTED=$TRUE
			  shutdown_time=300
			  ;;
			11)
			  VALID_SELECTED=$TRUE
			  shutdown_time=360
			  ;;
			12)
			  VALID_SELECTED=$TRUE
			  shutdown_time=420
			  ;;
			13)
			  VALID_SELECTED=$TRUE
			  shutdown_time=480
			  ;;
			14)
			  VALID_SELECTED=$TRUE
			  shutdown_time=540
			  ;;
			15)
			  VALID_SELECTED=$TRUE
			  shutdown_time=600
			  ;;

	       *)
              VALID_SELECTED=$FALSE                
              beep
              #Echo "Invalid Selection, input again"
			#Echo "Invalid input, Input again"
			Echo_wrong
        esac
		echo_line
    done		  
	


        Echo "4. First Warning Time "
		Echo "First warning time is the time when the first warning message will be sent out after AC fail occurs. Its value can be from 1 to 30000 seconds(default=30s)."
     VALID_SELECTED=$FALSE 
   while [ $VALID_SELECTED -eq $FALSE ]
    do
        Echo " First Warning Time After AC Fail(1~30000seconds) \\c"
	#	echo -e " [$first_time]: \\c"
		echo -e ":\\c"
        first_time_tmp=$first_time
		read  first_time
##		first_time=${first_time:=$first_time_tmp}
        first_time=${first_time:=30}
		IsDigital $first_time
		case "$?" in
		$FALSE)
			VALID_SELECTED=$FALSE
			beep
#			Echo "Invalid input, Input again"
			Echo_wrong
			;;
		
		$TRUE)
			if test $first_time -gt $first_time_max
			then
				VALID_SELECTED=$FALSE
				beep
				#Echo "Invalid input, Input again"
				Echo_wrong
			elif test $first_time -lt $first_time_min
			then
				VALID_SELECTED=$FALSE
				beep
				#Echo "Invalid input, Input again"
				Echo_wrong
			else
				VALID_SELECTED=$TRUE
			fi
		
			;;
	esac
	echo_line
    done

	Echo "5. Warning Interval"
	Echo "Warning Interval is the interval between two warning messages. Its value can be from 5 seconds to 30000 seconds(default=30s)"
       VALID_SELECTED=$FALSE 
   while [ $VALID_SELECTED -eq $FALSE ]
    do
     Echo " Warning Interval(5~30000seconds)  \\c"
	 #echo -e " [$interval]: \\c"
	 echo -e ": \\c"
	 	interval_tmp=$interval
        read interval
##		let interval=${interval:=$interval_tmp}
        interval=${interval:=30}
		IsDigital $interval
		case "$?" in
		$FALSE)
			VALID_SELECTED=$FALSE
			beep
			#Echo "Invalid input, Input again"
			Echo_wrong
			;;
		
		$TRUE)
			VALID_SELECTED=$TRUE
				if test $interval -gt $interval_max
			then
				VALID_SELECTED=$FALSE
				beep
				#Echo "Invalid input, Input again"
				Echo_wrong
			elif test $interval -lt $interval_min
			then
				VALID_SELECTED=$FALSE
				beep
				#Echo "Invalid input, Input again"
				Echo_wrong
			else
				VALID_SELECTED=$TRUE
			fi
		
			;;
	esac
	echo_line
    done




##############################################################
# Display the selection for verify
###############################################################
	Echo
	Echo "The following is the collection of selection you just made. "
	Echo 

	
	echo_line
	
	
    Echo "COM PORT\\c"
	if [ $ja -eq 0 ];then
	echo -e "\t\t\t\t\t:\\c"
	else
	echo -e "\t\t\t:\\c"
	fi
	decho "|$ComPortName|"
	Echo  "$ComPortName"

	Echo " AC Fail Delay(seconds) \\c"
	if [ $ja -eq 0 ];then
	echo -e "\t\t\t\t: ${delay}"
	else
	echo -e "\t\t: ${delay}"
	fi
    
    Echo " First Warning Time After AC Fail(seconds) \\c"
	if [ $ja -eq 0 ];then
	echo -e "\t: ${first_time}"
	else
	echo -e "\t\t\t\t: ${first_time}"
	fi
    
	  Echo " System Shutdown Needed Time(seconds) \\c"
	if [ $ja -eq 0 ];then
	echo -e "\t\t: $shutdown_time"
	else
	echo -e "\t: $shutdown_time"
	fi
    
     Echo " Warning Interval(seconds)  \\c"
	if [ $ja -eq 0 ];then
	echo -e "\t\t\t: $interval"
	else
	echo -e "\t\t\t\t: $interval"
	fi
    
 if [ 2 -eq 1 ]; then 
    Echo "COM PORT\\c"
#e	echo -e "\t\t\t\t\t:\\c"
	echo -e "\t\t\t:\\c"
	Echo  "$ComPortName"

	Echo " AC Fail Delay(seconds) \\c"
#e	echo -e "\t\t\t\t: ${delay}"
	echo -e "\t: ${delay}"
    
    Echo " First Warning Time After AC Fail(seconds) \\c"
#e	echo -e "\t: ${first_time}"
	echo -e "\t\t\t\t: ${first_time}"
    
	  Echo " System Shutdown Needed Time(seconds) \\c"
#e	echo -e "\t\t: $shutdown_time"
	echo -e "\t: $shutdown_time"
    
     Echo " Warning Interval(seconds)  \\c"
#e	echo -e "\t\t\t: $interval"
	echo -e "\t\t\t\t: $interval"
    


  #Echo "COM PORT: \\c"
    #Echo "COM PORT \t\t\t\t\t:\\c"
#	Echo  "$ComPortName"

#    	Echo "COM PORT\\c"
#	echo -e "\t\t\t\t\t:\\c"
#	Echo  "$ComPortName"
#	Echo " AC Fail Delay(seconds) \\c"
#	echo -e "\t\t\t\t: ${delay}"
    
#        Echo " First Warning Time After AC Fail(seconds) \\c"
#	echo -e "\t: ${first_time}"
    
#	  Echo " System Shutdown Needed Time(seconds) \\c"
#	echo -e "\t\t: $shutdown_time"
    
#     Echo " Warning Interval(seconds)  \\c"
#	echo -e "\t\t\t: $interval"
    
  fi
   
	echo_line
    Echo


#######################################################
#if not TRUE, exit
#else write them to config file
###################################################
#	IsYNLoop "Are the above selections correct?    \\c"
#	IsYNLoop "Are the above selections correct? If you want to accept them, please press [Y],if you want to modify them, please press [N]. Please input\\c"
#IsYNLoop "Are the above selections correct? press [Y] to accept them, press [N] to modify them. input\\c"
	prompt_modify_yn
	case "$?" in
		$NO)
			Echo 
			Echo "Please re-input the parameters again "
			Echo 
			Select_OK=$FALSE
			;;
		$YES)
			Select_OK=$TRUE
			;;
	esac
done
###################################################
# Write config file
##################################################
Echo 
Echo "now, build config file according to the selection "
Echo 
echo_line
	decho "##comset=$ComSet"	
	case "$ComSet" in
        1) $upsconfig -s "[ UPS ]" " ComSet" 0
		;;
        2) $upsconfig  -s "[ UPS ]" " ComSet" 1
        ;;
        3) $upsconfig  -s "[ UPS ]" " ComSet" 2
        ;;
	    4) $upsconfig  -s "[ UPS ]" " ComSet" 3
	    ;;
        5) $upsconfig  -s "[ UPS ]" " ComSet" 4
        ;;
        6) $upsconfig  -s "[ UPS ]" " ComSet" "-2"
        ;;
    esac

	$upsconfig -s "[ ShutDown ]" " EXPECTBLIFE" $delay
	$upsconfig -s "[ ShutDown ]" " FIRSTWARN" $first_time
	$upsconfig -s "[ ShutDown ]" " INTERVAL" $interval
	$upsconfig -s "[ ShutDown ]" " TurnOffDelay" $shutdown_time
	closeapp_time=`expr  $shutdown_time \/ 2`
	$upsconfig -s "[ ShutDown ]" " CloseAppTime" $closeapp_time	
	get_set_battery
	run_agent	
	exit

######################################################

